
(* a simple calculator *)

type arithmetic =
	| cst nat
	| neg arithmetic
	| add arithmetic * arithmetic
	| sub arithmetic * arithmetic
	| mul arithmetic * arithmetic
	| div arithmetic * arithmetic

internal define fold expr f =  
	case expr {
	| cst n = f.cst n
	| neg a = f.neg (fold a f)
	| add (a,b) = f.add (fold a f) (fold b f)
	| sub (a,b) = f.sub (fold a f) (fold b f)
	| mul (a,b) = f.mul (fold a f) (fold b f)
	| div (a,b) = f.div (fold a f) (fold b f)
	}
	  
define eval expr =
	fold expr {
	| cst n = ok n
	| neg a = ok1 a ( ~ )	
	| add a b = ok2 ( + ) a b  
	| sub a b = ok2 ( - ) a b  
	| mul a b = ok2 ( * ) a b  
	| div a b = result2 a b safe_division
	}
	 