
(* max-heaps implemented using primitive recursion,       *)
(* if only 'insert' is used then the heap is a Braun tree *)

type heap a =
	| empty
	| node (non_empty_heap a)
and non_empty_heap a =
	left : heap a * item : a * right : heap a 

internal define para s f resume = 
	case s {
	| empty = f.empty
	| node n = f.node n (para n.left f) (para n.right f) }

internal define cata2 ma mb f resume =
	case ma {
	| empty =
		f.empty_left mb
	| node a = 
	case mb {
	| empty =
		f.empty_right ma
	| node b =
		f.nodes a b
		(cata2 a.left a.right f) 
		(cata2 b.left b.right f) }
	}

define heap_max h =
	h.item

define heap_insert x h =
	para h {
	| empty x =
		empty, x, empty 
	| node n l r x =
		case (compare x n.item) {
		| more = n change (node (r resume n.item)) x n.left
		| else = n change (node (r resume x)) n.item n.left
		}
	}
	resume x

define heap_join ha hb =
	cata2 ha hb {
	| empty_left r = r
	| empty_right l = l
	| nodes a b ja jb = 
		node 
		( case (compare a.item b.item) {
		| more = a with left (ja resume) right (node b)
		| else = b with left (node a) right (jb resume)}
		)
	} resume
					
define heap_remove_max h =
	heap_join h.left h.right

		