
(* Mutable/immutable Double-Ended-queue *)

type queue a =
	| empty
	| node (non_empty_queue a)
and non_empty_queue a =
	front : non_empty_seq a * rear : seq a 

define queue_length q =
	case q {
	| empty = 0
	| node n = seq_length (node n.front) + seq_length n.rear)}
	}	
	
define queue_snoc q x =
	case q {
	| empty = (seq_cons x empty,empty)
	| node n = n with rear node(seq_cons x n.rear)}
	}
define queue_cons x q =
	case q {
	| empty = (seq_cons x empty,empty)
	| node n = n with front node(seq_make x n.front)}
	}
	
define queue_head q =
	q.front.head
	
define queue_tail q =
	case q.front.tail {
	| node t =
		node(q with front t)
	| empty =
		case q.rear {
		| empty = empty
		| node r = node(q change (seq_reverse r) empty) }
	}

define queue_last q =
	case q.rear {
	| node n = n.head
	| empty = seq_last q.front }

define queue_init q =
	case q.rear {
	| node r =
		node(q with rear r.tail)
	| empty =
		case q.front.tail {
		| empty = empty
		| node t = node(q with front (seq_init front)) }
	}
 	
define queue_append q1 q2 =
	case q1 {
	| empty = q2
	| node n1 =
	case q2 {
	| empty = q1
	| node n2 =
		node 
		{q1 change 
		(seq_append_rev n1.front n1.rear)  	
		(seq_append_rev n2.rear n2.front)  
		}}}
		