
(* a simple formal derivator *)

type fun =
	| var
	| cst nat
	| neg fun
	| add (fun * fun)
	| mul (fun * fun)
	| sin fun
	| cos fun
	| exp fun

internal define recu obj f =
	case obj {
	| var = f.var
	| cst n = f.cst n
	| neg u = f.neg u (recu u f)
	| add (u,v) = f.add (u,v) (recu u f) (recu v f)
	| mul (u,v) = f.mul (u,v) (recu u f) (recu v f)
	| sin u = f.sin u (recu u f)
	| cos u = f.cos u (recu u f)
	| exp u = f.exp u (recu u f)
	}
	
define deriv f =
	recu f {
	| var = cst 1
	| cst n = cst 0
	| neg _ du = neg du
	| add _ du dv = add (du,dv)
	| mul (u,v) du dv = add (mul (du,v), mul (u,dv))
	| sin u du = mul (du, cos u)
	| cos u du = neg (mul (du, sin u))
	| exp u du = mul (du, exp u)
	}
	
	