
(* an impossible interpreter for untyped lambda-calculus *)

type lexpr =
	(* expressions *)
	| var nat
	| abs lexpr
	| app (lexpr * lexpr)
	
type lval =
	(* this type is illegal *)
	(* see "Total Functional Programming" by David Turner *)
	| fun (lval -> lval)

internal define fold expr f =	
	case expr {
	| var n = f.var n
	| abs body = f.abs (fold body f)
	| app (op,arg) = f.app (fold op f) (fold arg f)

define eval expr env = 	
	fold expr {
	| var n e = seq_lookup n e
	| abs body e = fun (x |-> body (seq_cons x e))
	| app f arg e =
		let fun op = f e in op (arg e)
	} env

