
(* max-heaps that preserves insertion order *)
(* La lettre de Caml n5 *)

type heap a =
	| empty
	| node (non_empty_heap a)
and non_empty_heap a =
	left : heap a * item : a * right : heap a 
	
internal define bicata ma mb f resume =
	case ma {
	| empty =
		f.empty_left mb
	| node a = 
	case mb {
	| empty =
		f.empty_right ma
	| node b =
		f.nodes a b
		(bicata a.right mb f) 
		(bicata ma b.left f) }
	}

define heap_max h =
	h.item

define heap_join ha hb =
	bicata ha hb {
	| empty_left r = r
	| empty_right l = l
	| nodes a b ja jb = 
		node 
		( case (compare a.item b.item) {
		| more = a with right (ja resume)
		| else = b with left (jb resume)
		)
	} resume
	
define heap_insert x h =
	join h (node(empty,x,empty))
	
define heap_remove_max h =
   join h.left h.right
	
define heap_to_seq =
	fold h {
	| empty = empty	
	| node l x r =  seq_append l (seq_cons x r)
	}
	