
(* A Bi-Catamorphism example *)

let rec bifold l1 l2 case =
	match l1,l2 with
	| [],_ -> case#nil1 l2
	| _,[] -> case#nil2 l1 
	| h1::t1,h2::t2 ->
			if case#cond h1 h2
			then case#cons1 h1 (bifold t1 l2 case)
			else case#cons2 h2 (bifold l1 t2 case)

let merge l1 l2 =
	bifold l1 l2 (
		object
			method nil1 l2 = l2
			method nil2 l1 = l1
			method cond h1 h2 = h1 < h2 
			method cons1 h t = h::t
			method cons2 h t = h::t
		end )

(* merge [1;3;6;8;9] [2;4;7] *)

   