
(* a simple lambda-calculus strict interpreter *)

type lexpr =
	(* expressions *)
	| Var of int
	| Abs of lexpr
	| App of lexpr * lexpr
	(* extension
	| Let_in of lexpr * lexpr *)
	
type lval =
	(* values *)
	| Fun of (lval -> lval)

let rec fold expr case = 	
	match expr with
	| Var n -> case#var n
	| Abs body -> case#abs (fold body case)
	| App (f,arg) -> case#app (fold f case) (fold arg case)
(* | Let_in (e,body) -> case#let_in (fold e case) (fold body case) *)

let eval expr env = 	
	fold expr (
		object
			method var n e = List.nth e n
			method abs body e = Fun (fun x -> body (x::e))
			method app f arg e =
				let Fun op = f e in op (arg e)
		end ) env
