
(* Mutable/immutable linear sequences *)

module type Seq
	=
	sig
		type 'a seq =
			'a non_empty_seq option
		and 'a non_empty_seq =
			{head: 'a; tail: 'a seq}
		val cons: 'a -> 'a seq -> 'a non_empty_seq
		val make: 'a -> 'a non_empty_seq -> 'a non_empty_seq
		val length: 'a seq -> int
		val append: 'a seq -> 'a seq -> 'a seq
		(* to be implemented *)
		val reverse: 'a non_empty_seq -> 'a non_empty_seq
		val last: 'a non_empty_seq -> 'a
	end

